#include "chemistry/MoleculeColors.h"

namespace Game3 {
	std::unordered_map<std::string, HSL> moleculeColors{
		{"Ca5(PO4)3Cl", {190, 0.8, 0}},
		{"Mg3Si2H4O9", {10, 0, 0.25}},
		{"Al2O3", {30, 0.75, -0}},
		{"Cu5Fes4", {40, 0.9, -0.25}},
		{"SnO2", {10, 0, -0.05}},
		{"CuFeS2", {50, 0.4, -0.03}},
		{"FeCr2O4", {300, 0.1, -0.1}},
		{"BeAl2O4", {80, 0.25, -0.1}},
		{"(Al2Mg3Si3O12)3(Al2Fe3Si3O12)5(Al2Mn3Si3O12)8", {10, 0.7, -0.1}},
		{"FeTiO3", {0, 0, -0.5}},
		{"Fe3O4", {0, 0, -0.1}},
		{"Cu2CH2O5", {120, 0.7, -0.2}},
		{"KAl3Si3F2O10", {50, 0.25, 0.1}},
		{"Mg2Fe(SiO2)2", {90, 1, -0.1}},
		{"FeS2", {40, 0.5, -0.05}},
		{"Ca2Nb2O7", {0, 0.9, -0.25}},
		{"Al2Mg3Si3O12", {20, 0.4, -0.15}},
		{"Al3Si3Na4Cl", {240, 0.7, 0}},
		{"Sb2S3", {210, 0.5, -0.25}},
		{"S", {45, 0.666, 0}},
		{"Cu3SbS3Fe", {160, 0.1, -0.05}},
		{"(Fe3O4)V", {240, 0.1, -0.1}},
		{"Fe", {10, 0.3, 0}},
		{"H", {240, 1, 0}},
		{"H2", {240, 1, 0.1}},
		{"He", {0, 0, 0.42}},
		{"U", {120, 1, 0}},
		{"Si", {0, 0, -0.1}},
		{"O", {0, 1, -0.1}},
		{"O2", {0, 1, 0.0}},
		{"O3", {0, 1, 0.1}},
		{"C", {0, 0, -0.5}},
		{"N", {240, 0.05, 0.3}},
		{"N2", {240, 0.05, 0.4}},
		{"NH3", {240, 0.05, 0.2}},
		{"C12H20O10", {120, 0.8, 0}},
		{"H2O", {240, 0.8, 0.1}},
		{"CO2", {0, 0, -0.2}},
		{"SiO2", {0, 0, 0.3}},
		{"C39H35O10NS", {30, 0.5, -0.3}},
		{"Al2Si2O5(OH)4", {240, 0.1, 0.3}},
		{"Al2Co2O5", {215, 1, -0.3}},
		{"CuCl2", {100, 1, 0}},
		{"BaSO4", {0, 0, 0.1}},
		{"NiCl2", {120, 1, -0.1}},
		{"Sb2O3", {215, 1, -0.1}},
		{"CdS", {60, 1, 0}},
		{"Cr2O3", {120, 1, 0.1}},
		{"K2Cr2O7", {0, 1, 0.1}},
		{"As4S3", {40, 1, 0}},
		{"KMnO4", {275, 1, 0}},
		{"HgS", {10, 1, -0.1}},
	};
}
