#include "chemistry/MoleculeNames.h"

namespace Game3 {
	std::unordered_map<std::string, std::string> moleculeNames{
		{"C12H20O10", "Cellulose"},
		{"H2O", "Water"},
		{"CO2", "Carbon Dioxide"},
		{"N2", "Dinitrogen"},
		{"H2", "Dihydrogen"},
		{"O3", "Ozone"},
		{"O2", "Dioxygen"},
		{"H", "Hydrogen"},
		{"O", "Oxygen"},
		{"C", "Carbon"},
		{"N", "Nitrogen"},
		{"Si", "Silicon"},
		{"U", "Uranium"},
		{"Fe", "Iron"},
		{"SiO2", "Silica"},
		{"Al2Si2O5(OH)4", "Kaolinite"},
		{"C39H35O10NS", "Lignite"},
		{"NH3", "Ammonia"},
		{"C2H4", "Ethylene"},
		{"S", "Sulfur"},
		{"TiO2", "Titanium oxide"},
		{"Al2Co2O5", "Cobalt aluminate"},
		// {"C12H22O11", "Sucrose"}, // nvm. Lactose has the same formula, so we're just going to leave it nameless
		{"CuCl2", "Copper chloride"},
		{"BaSO4", "Barium sulfate"},
		{"NiCl2", "Nickel chloride"},
		{"Sb2O3", "Antimony trioxide"},
		{"CdS", "Cadmium sulfide"},
		{"Cr2O3", "Chromium(III) oxide"},
		{"K2Cr2O7", "Potassium dichromate"},
		{"As4S3", "Dimorphite"},
		{"KMnO4", "Potassium permanganate"},
		{"HgS", "Mercury sulfide"},
		{"Ca5(PO4)3OH", "Hydroxyapatite"},
		{"PbI2", "Lead iodide"},
		{"NO3", "Nitrate"},
		{"C40H56", "Beta carotene"},
		{"C32H44O8", "Cucurbitacin E"},
		{"C4H10", "Butane"},
		{"C5H12", "Pentane"},
		{"C18H27NO3", "Capsaicin"},
		{"C3H7N3O2", "Ethylnitrosourea"},
		{"Ca5(PO4)3Cl", "Apatite"},
		{"Mg3Si2H4O9", "Asbestos"},
		{"Al2O3", "Bauxite"},
		{"Cu5FeS4", "Bornite"},
		{"SnO2", "Cassiterite"},
		{"CuFeS2", "Chalcopyrite"},
		{"FeCr2O4", "Chromite"},
		{"BeAl2O4", "Chrysoberyl"},
		{"(Al2Mg3Si3O12)3(Al2Fe3Si3O12)5(Al2Mn3Si3O12)8", "Garnet"},
		{"FeTiO3", "Ilmenite"},
		{"Fe3O4", "Magnetite"},
		{"Cu2CH2O5", "Malachite"},
		{"KAl3Si3F2O10", "Mica"},
		{"Mg2Fe(SiO2)2", "Olivine"},
		{"FeS2", "Pyrite"},
		{"Ca2Nb2O7", "Pyrochlore"},
		{"Al2Mg3Si3O12", "Pyrope"},
		{"Al3Si3Na4Cl", "Sodalite"},
		{"Sb2S3", "Stibnite"},
		{"S", "Sulfur"},
		{"Cu3SbS3Fe", "Tetrahedrite"},
		{"(Fe3O4)V", "Vanadium magnetite"},
	};
}
